class drawRect {
  float angV=3;
  void display() {

    pushMatrix();    
    //interactivity for display 
    if (horizontal) {
      if (ang!=0) {  //star
        angV=3;
        ang = ang-angV;
        if (ang<0) {
          angV=0;
        }
      }
      rotateX(radians(ang));
      translate(width/2, height/2, zpos);
    } else {         //arch
      ang = ang+angV;
      if (ang>90) {
        angV=0;
      }
      translate(width/2, height/4, zpos);
      rotateX(radians(ang));
    }


    for (int i =0; i<numRows; i++) {
      String title = table.getString(i, 3);//title
      title = title.toUpperCase();
      String domain = table.getString(i, 2);//domain
      domain = domain.toUpperCase();
      String clock = table.getString(i, 1); //Num AM and PM     
      float time = map(table.getFloat(i, 1), 6, 17, 0, timeN);//time
      float ang = map(table.getFloat(i, 1), 0, 24, 0, 720); //clockHand
      float depth = map(table.getFloat(i, 1), 6, 17, 0, depthN);
      float count = map(table.getFloat(i, 8), 88, 301, 2, 9);//typesize 
      float trans = map(table.getFloat(i, 8), 88, 301, 155, 255);//transparency
      float timeReal=table.getFloat(i, 1);

      pushMatrix();
      translate((i%sqrt(numRows+1))*unit*sin(i), unit*(i/sqrt(numRows+1))*cos(i), -depth);
      rotateZ(radians(ang2+35));
      rotateY(radians(ang3));
      textSize(count);
      text (clock, 10, 0);//number

      //domain
      pushMatrix();
      textSize(count);      
      textAlign(CENTER, TOP);      
      text(timeReal + " " + domain, 0, 0);
      popMatrix();

      //Separating day and night - different rotation 
      pushMatrix();
      if (time<timeN/2 || time==timeN/2) {
        rotateY(PI/2);
      } else {
        rotateY(-PI/2);
      }
      textSize(count);
      fill(white, trans);
      textAlign(LEFT, TOP);
      title = title.toUpperCase();
      text(title, 0, 0, count*10, 300); 
      popMatrix();

      //Draw clock
      pushMatrix();
      noStroke();
      fill(white, trans);     
      rotateZ(radians(ang));
      rectMode(LEFT);
      rect(0, 0, time, .6); //clockhands
      noFill();
      strokeWeight(count);           
      stroke(white, random(150, 255));
      point(0, 0, 0); //clock points
      popMatrix();
      popMatrix();
    }

    //Connecting the earliest time and the latest time of each day
    beginShape();
    for (int j =0; j<numRows; j++) {
      float d = map(table.getFloat(j, 1), 6, 17, 0, depthN);
      if (d==0 || d==depthN) {
        stroke(white);
        strokeWeight(.3);
        vertex((j%sqrt(numRows+1))*unit*sin(j), unit*(j/sqrt(numRows+1))*cos(j), -d);
      }
    }
    endShape();
    pushMatrix();

    //interactivity for displaying different time
    if (day1) {
      frame=frame+vFrame;
      frameBar = map(frame, 0, 200, 0, unitH*11);
      beginShape();
      for (int j =0; j<numRows; j++) {
        float d = map(table.getFloat(j, 1), 6, 17, 0, depthN);
        if (horizontal) {
          noFill();
          strokeWeight(5);
          stroke(white);
        } else {
          fill(white, 80);
          strokeWeight(3);
          stroke(white, random(150, 255));
        }
        //3/13
        if (j<120&&frame<10) {    
          curveVertex((j%sqrt(numRows+1))*unit*sin(j), unit*(j/sqrt(numRows+1))*cos(j), -d);
        }
        //3/15
        if (j>119 && j<235&&frame>15&frame<25) {  
          curveVertex((j%sqrt(numRows+1))*unit*sin(j), unit*(j/sqrt(numRows+1))*cos(j), -d);
        }
        //3/16
        if (j>323 && j<420&&frame>30&frame<40) {  
          curveVertex((j%sqrt(numRows+1))*unit*sin(j), unit*(j/sqrt(numRows+1))*cos(j), -d);
        }
        //3/17
        if (j>419 && j<523&&frame>45&frame<55) {  
          curveVertex((j%sqrt(numRows+1))*unit*sin(j), unit*(j/sqrt(numRows+1))*cos(j), -d);
        }
        //3/18
        if (j>522 && j<626&&frame>60&frame<70) {  
          curveVertex((j%sqrt(numRows+1))*unit*sin(j), unit*(j/sqrt(numRows+1))*cos(j), -d);
        }
        //3/19
        if (j>625 && j<927&&frame>75&frame<85) {  
          curveVertex((j%sqrt(numRows+1))*unit*sin(j), unit*(j/sqrt(numRows+1))*cos(j), -d);
        }
        //3/20
        if (j>936 && j<1024&&frame>90&frame<100) {  
          curveVertex((j%sqrt(numRows+1))*unit*sin(j), unit*(j/sqrt(numRows+1))*cos(j), -d);
        }
        //3/21
        if (j>1023 && j<1146&&frame>105&frame<115) {  
          curveVertex((j%sqrt(numRows+1))*unit*sin(j), unit*(j/sqrt(numRows+1))*cos(j), -d);
        }
        //3/22
        if (j>1145 && j<1238 &&frame>120&frame<130) {  
          curveVertex((j%sqrt(numRows+1))*unit*sin(j), unit*(j/sqrt(numRows+1))*cos(j), -d);
        }
        //3/23
        if (j>1237 && j<1146 &&frame>135&frame<145) {  
          curveVertex((j%sqrt(numRows+1))*unit*sin(j), unit*(j/sqrt(numRows+1))*cos(j), -d);
        }
        //3/24
        if (j>1145 && j<1238 &&frame>150&frame<160) {  
          curveVertex((j%sqrt(numRows+1))*unit*sin(j), unit*(j/sqrt(numRows+1))*cos(j), -d);
        }
        //3/25
        if (j>1237 && j<1338&&frame>165&frame<175) {  
          curveVertex((j%sqrt(numRows+1))*unit*sin(j), unit*(j/sqrt(numRows+1))*cos(j), -d);
        }
        //3/26
        if (j>1337 && j<1448 &&frame>180&frame<190) {  
          curveVertex((j%sqrt(numRows+1))*unit*sin(j), unit*(j/sqrt(numRows+1))*cos(j), -d);
        }
        if (frame>200) {
          frame=0;
        }
      } 
      endShape();
    } else {
      frame=0;
    }
    popMatrix();
    popMatrix();
  }
}